diff --git a/lib/tpm2_openssl.c b/lib/tpm2_openssl.c
index 8a7303182b..e2be28c627 100644
--- a/lib/tpm2_openssl.c
+++ b/lib/tpm2_openssl.c
@@ -130,3 +130,29 @@ void tpm2_openssl_hmac_free(HMAC_CTX *ctx) {
     HMAC_CTX_free(ctx);
 #endif
 }
+
+EVP_CIPHER_CTX *tpm2_openssl_cipher_new(void) {
+    EVP_CIPHER_CTX *ctx;
+#if OPENSSL_VERSION_NUMBER < 0x1010000fL || defined(LIBRESSL_VERSION_NUMBER) /* OpenSSL 1.1.0 */
+    ctx = malloc(sizeof(*ctx));
+#else
+    ctx = EVP_CIPHER_CTX_new();
+#endif
+    if (!ctx)
+        return NULL;
+
+#if OPENSSL_VERSION_NUMBER < 0x1010000fL || defined(LIBRESSL_VERSION_NUMBER)
+    EVP_CIPHER_CTX_init(ctx);
+#endif
+
+    return ctx;
+}
+
+void tpm2_openssl_cipher_free(EVP_CIPHER_CTX *ctx) {
+#if OPENSSL_VERSION_NUMBER < 0x1010000fL || defined(LIBRESSL_VERSION_NUMBER)
+    EVP_CIPHER_CTX_cleanup(ctx);
+    free(ctx);
+#else
+    EVP_CIPHER_CTX_free(ctx);
+#endif
+}
diff --git a/lib/tpm2_openssl.h b/lib/tpm2_openssl.h
index 8fb35d3140..2beaf9015e 100644
--- a/lib/tpm2_openssl.h
+++ b/lib/tpm2_openssl.h
@@ -70,4 +70,21 @@ void tpm2_openssl_hmac_free(HMAC_CTX *ctx);
 bool tpm2_openssl_hash_pcr_values(TPMI_ALG_HASH halg,
         TPML_DIGEST *digests, TPM2B_DIGEST *digest);
 
+/**
+ * Obtains an OpenSSL EVP_CIPHER_CTX dealing with version
+ * API changes in OSSL.
+ *
+ * @return
+ *  An Initialized OpenSSL EVP_CIPHER_CTX.
+ */
+EVP_CIPHER_CTX *tpm2_openssl_cipher_new(void);
+
+/**
+ * Free's an EVP_CIPHER_CTX obtained via tpm2_openssl_cipher_new()
+ * dealing with OSSL API version changes.
+ * @param ctx
+ *  The EVP_CIPHER_CTX to free.
+ */
+void tpm2_openssl_cipher_free(EVP_CIPHER_CTX *ctx);
+
 #endif /* LIB_TPM2_OPENSSL_H_ */
diff --git a/tools/tpm2_import.c b/tools/tpm2_import.c
index 2ec2c54be9..d853a6bbd7 100644
--- a/tools/tpm2_import.c
+++ b/tools/tpm2_import.c
@@ -275,15 +275,14 @@ bool aes_encrypt_buffers(TPMT_SYM_DEF_OBJECT *sym, uint8_t *encryption_key,
         return false;
     }
 
-    EVP_CIPHER_CTX ctx;
-    EVP_CIPHER_CTX_init(&ctx);
+    EVP_CIPHER_CTX *ctx = tpm2_openssl_cipher_new();
 
-    int rc = EVP_EncryptInit_ex(&ctx, cipher, NULL, encryption_key, iv);
+    int rc = EVP_EncryptInit_ex(ctx, cipher, NULL, encryption_key, iv);
     if (!rc) {
         return false;
     }
 
-    EVP_CIPHER_CTX_set_padding(&ctx, 0);
+    EVP_CIPHER_CTX_set_padding(ctx, 0);
 
     uint8_t *bufs[2] = {
         buf1,
@@ -307,7 +306,7 @@ bool aes_encrypt_buffers(TPMT_SYM_DEF_OBJECT *sym, uint8_t *encryption_key,
 
         int output_len = total_len - offset;
 
-        rc = EVP_EncryptUpdate(&ctx, &cipher_text->buffer[offset], &output_len - offset, b, l);
+        rc = EVP_EncryptUpdate(ctx, &cipher_text->buffer[offset], &output_len - offset, b, l);
         if (!rc) {
             LOG_ERR("Encrypt failed");
             goto out;
@@ -317,7 +316,7 @@ bool aes_encrypt_buffers(TPMT_SYM_DEF_OBJECT *sym, uint8_t *encryption_key,
     }
 
     int tmp_len = 0;
-    rc = EVP_EncryptFinal_ex(&ctx, NULL, &tmp_len);
+    rc = EVP_EncryptFinal_ex(ctx, NULL, &tmp_len);
     if (!rc) {
         LOG_ERR("Encrypt failed");
         goto out;
@@ -328,7 +327,7 @@ bool aes_encrypt_buffers(TPMT_SYM_DEF_OBJECT *sym, uint8_t *encryption_key,
     result = true;
 
 out:
-    EVP_CIPHER_CTX_cleanup(&ctx);
+    tpm2_openssl_cipher_free(ctx);
 
     return result;
 }
